#include <stdio.h>
#include <assert.h>
#include "fbbitblt.h"
#include "libfb.h"
#include "fbevent.h"	/* for debugging */

/*#define BBDEBUG*/

#define SWAP(s)	s=0x0000 | (s<<16)
#define RSWAP(s) s=0x00000000 | (s>>16)
#define	WSWAP(s) ((s<<16)|(s>>16))
#define UPPER(s) (((s)<<16) & 0xFFFF0000)
 
#define	LOGICOP(d,s,logicop)			\
	switch(logicop)				\
	{					\
	case 0x0: d = 0x0000;		break;	\
	case 0x1: d = (s) & (d);	break;	\
	case 0x2: d = (s) & ~(d);	break;	\
	case 0x3: d = (s);		break;	\
	case 0x4: d = ~(s) & (d);	break;	\
	case 0x5:	/* dest */	break;	\
	case 0x6: d = (s) ^ (d);	break;	\
	case 0x7: d = (s) | (d);	break;	\
	case 0x8: d = ~ (s) & ~ (d);	break;	\
	case 0x9: d = ~ (s) ^ (d);	break;	\
	case 0xA: d = ~ (d);		break;	\
	case 0xB: d = (s) | ~ (d);	break;	\
	case 0xC: d = ~ (s);		break;	\
	case 0xD: d = ~ (s) | (d);	break;	\
	case 0xE: d = ~ (s) | ~ (d);	break;	\
	case 0xF: d = 0xFFFF;		break;	\
	}

#define	LOGICOPEND(d,s,logicop,endmask)				\
	switch(logicop)						\
	{							\
	case 0x0: d |= 0x0000 & endmask;		break;	\
	case 0x1: d |= ((s) & (d)) & endmask;		break;	\
	case 0x2: d |= ((s) & ~(d)) & endmask;		break;	\
	case 0x3: d |= (s) & endmask;			break;	\
	case 0x4: d |= (~(s) & (d)) & endmask;		break;	\
	case 0x5:	/* dest */			break;	\
	case 0x6: d |= ((s) ^ (d)) & endmask;		break;	\
	case 0x7: d |= ((s) | (d)) & endmask;		break;	\
	case 0x8: d |= (~ (s) & ~ (d)) & endmask;	break;	\
	case 0x9: d |= (~ (s) ^ (d)) & endmask;		break;	\
	case 0xA: d |= (~ (d)) & endmask;		break;	\
	case 0xB: d |= ((s) | ~ (d)) & endmask;		break;	\
	case 0xC: d |= (~ (s)) & endmask;		break;	\
	case 0xD: d |= (~ (s) | (d)) & endmask;		break;	\
	case 0xE: d |= (~ (s) | ~ (d)) & endmask;	break;	\
	case 0xF: d |= 0xFFFF & endmask;		break;	\
	}

void bitblt( FB *f, FBBLTPBLK *fbb )
{
	register unsigned short *dbase=(__u16 *)((__u8 *)fbb->d_form + (( fbb->d_ymin * fbb->d_nxln ) + ( ( fbb->d_xmin / 16 ) * fbb->d_nxwd )));
	register unsigned short *sbase=(__u16 *)((__u8 *)fbb->s_form + (( fbb->s_ymin * fbb->s_nxln ) + ( ( fbb->s_xmin / 16 ) * fbb->s_nxwd )));
	unsigned short pc;
	unsigned short op_tabidx,logicop=0;
	unsigned short *s,*d,*lsbase,*ldbase;
	unsigned short i,j;
	unsigned int snxline,dnxline;
	short	snxword,dnxword;
	unsigned short s_xmax=fbb->s_xmin+fbb->b_wd-1;
	unsigned short d_xmax=fbb->d_xmin+fbb->b_wd-1;
	unsigned short lf_endmask[]={ 	0xFFFF, 0x7FFF, 0x3FFF, 0x1FFF,
					0x0FFF, 0x07FF, 0x03FF, 0x01FF,
					0x00FF, 0x007F, 0x003F, 0x001F,
					0x000F, 0x0007, 0x0003, 0x0001, 0x0000 };
	unsigned short *rt_endmask=&lf_endmask[1];
	unsigned short lendmsk=lf_endmask[fbb->d_xmin%16];
	unsigned short rendmsk=~rt_endmask[d_xmax%16];
	unsigned short endmask1,endmask3;
	unsigned short skew=((fbb->d_xmin%16)-(fbb->s_xmin%16)) & 0x000F;
	/*int		prefetch=((fbb->s_xmin % 16) != 0 ) ? TRUE : FALSE;*/
	int		prefetch=( skew != 0 ) ? TRUE : FALSE;
	unsigned short equalspans=(((s_xmax/16)-(fbb->s_xmin/16)) ==
					((d_xmax/16)-(fbb->d_xmin/16)) );

#ifdef BBDEBUG
	printf("skew: %hd equalspans: %hd\n",skew,equalspans);
#endif
	if ( ( fbb->b_wd <= 16 ) && ( ( fbb->d_xmin / 16 ) == ( d_xmax / 16 ) ) )
	{
		/* Blit left to right */

		/* Adjust sbase and dbase to top of block */

		/* No adjustment needed */

		/* Set next line offsets */

		snxline = fbb->s_nxln>>1;
		dnxline = fbb->d_nxln>>1;

		/* Set next word offsets */

		snxword = ( ( fbb->s_xmin / 16 ) != ( s_xmax / 16 ) ) ? fbb->s_nxwd>>1 : 0;
		dnxword = 0;

		/* Set endmask */
#ifdef BBDEBUG
		printf("lendmsk is %x rendmsk is %x\n",lendmsk,rendmsk);
#endif
		endmask1 = ( lendmsk & 0xFF00 ) | ( rendmsk & 0x00FF );
		endmask3 = 0;
	}
	else if ( fbb->s_ymin < fbb->d_ymin )
	{
#ifdef BBDEBUG
		printf("fbbitblt: bottom to top\n");
#endif
		/* Blit bottom to top */

		/* Adjust sbase and dbase to bottom of block */

		(__u8 *) dbase += ( fbb->d_nxln * ( fbb->b_ht - 1 ) );
		(__u8 *) sbase += ( fbb->s_nxln * ( fbb->b_ht - 1 ) );

		/* Set next line offsets */

		snxline = - (fbb->s_nxln>>1);
		dnxline = - (fbb->d_nxln>>1);

		/* Set next word offsets */

		snxword = fbb->s_nxwd>>1;
		dnxword = fbb->d_nxwd>>1;

		/* Set endmasks */

		endmask1 = lendmsk;
		endmask3 = rendmsk;
	}
	else if ( fbb->s_ymin > fbb->d_ymin )
	{
#ifdef BBDEBUG
		printf("fbbitblt: top to bottom\n");
#endif
		/* Blit top to bottom */

		/* Adjust sbase and dbase */

		/* no adjustment needed, already set to top of block */

		/* Set next line offsets */

		snxline = fbb->s_nxln>>1;
		dnxline = fbb->d_nxln>>1;

		/* Set next word offsets */

		snxword = fbb->s_nxwd>>1;
		dnxword = fbb->d_nxwd>>1;

		/* Set endmasks */

		endmask1 = lendmsk;
		endmask3 = rendmsk;
	}
	else if ( fbb->s_xmin < fbb->d_xmin )
	{
#ifdef BBDEBUG
		printf("fbbitblt: top to bottom, right to left\n");
#endif
		/* Blit top to bottom, right to left */

		/* Adjust sbase and dbase to top right of block */

		(__u8 *) dbase += ( ( ( ( fbb->b_wd - 1 ) / 16 ) + ( ( fbb->d_xmin % 16 ) != 0 )) * fbb->d_nxwd );
		(__u8 *) sbase += ( ( ( ( fbb->b_wd - 1 ) / 16 ) + ( ( fbb->s_xmin % 16 ) != 0 )) * fbb->s_nxwd );
		/*(__u8 *) dbase += ((( d_xmax / 16 ) - ( fbb->d_xmin / 16 ))*fbb->d_nxwd);*/
		/*(__u8 *) sbase += ((( s_xmax / 16 ) - ( fbb->s_xmin / 16 ))*fbb->s_nxwd);*/

		/* Set next line offsets */

		snxline = fbb->s_nxln>>1;
		dnxline = fbb->d_nxln>>1;

		/* Set next word offsets */

		snxword = - (fbb->s_nxwd>>1);
		dnxword = - (fbb->d_nxwd>>1);

		/* Set endmasks */

		endmask1 = rendmsk;
		endmask3 = lendmsk;
	}
	else
	{
		/* Blit top to bottom, left to right */

		/* Adjust sbase and dbase */

		/* no adjustment needed, already set to top of block */

		/* Set next line offsets */

		snxline = fbb->s_nxln>>1;
		dnxline = fbb->d_nxln>>1;

		/* Set next word offsets */

		snxword = fbb->s_nxwd>>1;
		dnxword = fbb->d_nxwd>>1;

		/* Set endmasks */

		endmask1 = lendmsk;
		endmask3 = rendmsk;
	}

	/* Blit each plane */

	for (	pc=1 ;
		pc<=fbb->plane_ct ;
		pc++,sbase+=fbb->s_nxpl>>1,dbase+=fbb->d_nxpl>>1 )
	{
		/* Calculate index into op_tab */

		op_tabidx = ( ( ( fbb->fg_col>>(pc - 1) ) & 0x0001 ) <<1 ) |
				(( fbb->bg_col>>(pc - 1) ) & 0x0001 );
		assert( op_tabidx<=3 );
#ifdef BBDEBUG
		printf("op_tabidx is %hd\n",op_tabidx);
#endif
		/* Get logic op for this plane from op_tab */

		logicop = ((char *) &fbb->op_tab)[op_tabidx];
		assert( logicop<=15 );
#ifdef BBDEBUG
		printf("logicop is %hd\n",logicop);
#endif
		/* Do for each line in the blit */

	if (snxword>=0)
	{
#ifdef BBDEBUG
		printf("left to right blit entered\n");
#endif
		for (	j=0,lsbase=sbase,ldbase=dbase ;
			j<fbb->b_ht ;
			j++,lsbase+=snxline,ldbase+=dnxline )
		{
			unsigned int sourcebuf=0x00000000;
			
#ifdef BBDEBUG
			printf("lsbase is %p ldbase is %p snxline is %d dnxline is %d\n",lsbase,ldbase,snxline,dnxline);
#endif
			s=lsbase;
			d=ldbase;

			/* If source pixel on word boundary, don't prefetch */

			if ( prefetch )
			{
#ifdef BBDEBUG
				printf("prefetching\n");
#endif
				sourcebuf|=*s;
				s += snxword;
				SWAP(sourcebuf);
			}

			sourcebuf|=*s;

			/* Do first word */

			LOGICOPEND(*d,(unsigned short)(sourcebuf>>skew),logicop,endmask1)

			/* One word blit */

			if (dnxword==0)
				continue;

			s += snxword;
			d += dnxword;
			SWAP(sourcebuf);
			sourcebuf|=*s;

			/* Do middle words */

			for (	i=0 ;
				/*i< ((fbb->b_wd /16) + (!equalspans) ((fbb->b_wd % 16) != 0 ) - 2 ) ;*/
				i< (((d_xmax / 16) - (fbb->d_xmin / 16)) - 1 ) ;
				i++,s+=snxword,d+=dnxword,SWAP(sourcebuf),sourcebuf|=*s )
			{
				LOGICOP(*d,(unsigned short)(sourcebuf>>skew),logicop)
			}

			/* Do last word */

			LOGICOPEND(*d,(unsigned short)(sourcebuf>>skew),logicop,endmask3)
		}
	}
	else
	{
#ifdef BBDEBUG
		printf("right to left blit entered\n");
		printf("endmask1 is %x endmask3 is %x\n",endmask1,endmask3);
#endif
		for (	j=0,lsbase=sbase,ldbase=dbase ;
			j<fbb->b_ht ;
			j++,lsbase+=snxline,ldbase+=dnxline )
		{
			unsigned int sourcebuf=0x00000000;
			
#ifdef BBDEBUG
			printf("lsbase is %p ldbase is %p snxline is %d dnxline is %d\n",lsbase,ldbase,snxline,dnxline);
#endif
			s=lsbase;
			d=ldbase;
			sourcebuf|= UPPER(*s);

			s += snxword;
			RSWAP(sourcebuf);
			sourcebuf|= UPPER(*s);


			/* Do first word */

			LOGICOPEND(*d,(unsigned short)(sourcebuf>>skew),logicop,endmask1)

			s += snxword;
			d += dnxword;
			RSWAP(sourcebuf);
			sourcebuf|=UPPER(*s);

			/* Do middle words */

			for (	i=0 ;
				/*i< ((fbb->b_wd /16) + (!equalspans) ((fbb->b_wd % 16) != 0 ) - 2 ) ;*/
				i< (((d_xmax / 16) - (fbb->d_xmin / 16)) - 1 ) ;
				i++,s+=snxword,d+=dnxword,RSWAP(sourcebuf),sourcebuf|=UPPER(*s) )
			{
				LOGICOP(*d,(unsigned short)(sourcebuf>>skew),logicop)
			}

			/* Do last word */

			LOGICOPEND(*d,(unsigned short)(sourcebuf>>skew),logicop,endmask3)
		}
	}
	}
}
